package com.ningdatech.pmapi.gov.convert;

import cn.hutool.core.bean.BeanUtil;
import com.ningdatech.pmapi.gov.model.dto.*;
import com.ningdatech.pmapi.gov.model.req.*;

import java.util.Objects;

/**
 * @Classname ProjectConvert
 * @Description
 * @Date 2023/8/25 11:53
 * @Author PoffyZhang
 */
public class ProjectConvert {

    /**
     * 6个 转换方法
     * @param saveDTO
     * @return
     */
    public static ProjectPushReq convert(GovBizProjectSaveDTO saveDTO) {
        ProjectPushReq req = new ProjectPushReq();
        req.setBaseinfo(convertBase(saveDTO.getBaseinfo()));
        req.setApply(convertApply(saveDTO.getApply()));
        req.setApprove(convertApprove(saveDTO.getApprove()));
        req.setCimplement(convertCimplement(saveDTO.getCimplement()));
        req.setMimplement(convertMimplement(saveDTO.getMimplement()));
        req.setProcure(convertProcure(saveDTO.getProcure()));
        return req;
    }

    private static ProjectProcureReq convertProcure(GovBizProjectProcureDTO procure) {
        ProjectProcureReq req = BeanUtil.copyProperties(procure,ProjectProcureReq.class);
        return req;
    }

    private static ProjectMimplementReq convertMimplement(GovBizProjectMimplementDTO mimplement) {
        ProjectMimplementReq req = BeanUtil.copyProperties(mimplement,ProjectMimplementReq.class);
        return req;
    }

    public static ProjectCimplementReq convertCimplement(GovBizProjectCimplementDTO cimplement) {
        ProjectCimplementReq req = BeanUtil.copyProperties(cimplement,ProjectCimplementReq.class);
        return req;
    }

    public static ProjectApproveReq convertApprove(GovBizProjectApproveDTO approve) {
        ProjectApproveReq req = new ProjectApproveReq();
        req.setBaseProjId(approve.getBaseProjId());
        req.setBaseProjName(approve.getBaseProjName());
        req.setOp(approve.getOp());
        req.setApprovalFile(approve.getApprovalFile());
        req.setBaseReviewCommentsFile(approve.getBaseReviewCommentFile());
        req.setPreliminaryDesignFile(approve.getPreliminaryDesignFile());
        req.setAreaCode(approve.getAreaCode());
        req.setBaseDevelopCode(approve.getBaseDevelopCode());
        req.setBaseExpertTotalMoney(String.valueOf(approve.getBaseExpertTotalMoney()));
        req.setBaseExpertYearMoney(String.valueOf(approve.getBaseExpertYearMoney()));
        req.setReleaseYearMoney(String.valueOf(approve.getReleaseYearMoney()));
        req.setBaseInitialReviewTotalMoney(String.valueOf(approve.getBaseInitialReviewTotalMoney()));
        req.setBaseReviewOpinion(approve.getBaseReviewOpinion());
        req.setBaseReviewResults(approve.getBaseReviewResults());
        req.setEqualProtectionLevel(approve.getEqualProtectionLevel());
        req.setPreliminaryDesignScheme(approve.getPreliminaryDesignScheme());
        req.setSetProjCodeFinan(approve.getSetProjCodeFinan());
        return req;
    }

    public static ProjectApplyReq convertApply(GovBizProjectApplyDTO apply) {
        ProjectApplyReq req = new ProjectApplyReq();
        if(Objects.isNull(apply)){
            return req;
        }
        req.setOp(apply.getOp());
        req.setBaseProjId(apply.getBaseProjId());
        req.setBaseProjName(apply.getBaseProjName());
        req.setAreaCode(apply.getAreaCode());
        req.setBaseAccountAppName(apply.getBaseAccountAppName());
        req.setBaseBasisEstablish(apply.getBaseBasisEstablish());
        req.setBaseCoreBusiness(apply.getBaseCoreBusiness());
        req.setBaseCoreBusinessCode(apply.getBaseCoreBusinessCode());
        req.setBaseBrainName(apply.getBaseBrainName());
        req.setBaseDevelopCode(apply.getBaseDevelopCode());
        req.setBaseLowestLevel(apply.getBaseLowestLevel());
        req.setBaseHistorProjId(apply.getBaseHistorProjId());
        req.setBaseHistorProjName(apply.getBaseHistorProjName());
        req.setBaseOperatMaintenFile(apply.getBaseOperatMaintenFile());
        req.setBaseProjApplyFile(apply.getBaseProjApplyFile());
        req.setBaseProjBasisFile(apply.getBaseProjBasisFile());
        req.setBaseProjOtherFile(apply.getBaseProjOtherFile());
        req.setBaseResearchReportFile(apply.getBaseResearchReportFile());
        req.setBaseProjConsClass(apply.getBaseProjConsClass());
        req.setBaseProjDuration(String.valueOf(apply.getBaseProjDuration()));
        req.setBaseProjIntro(apply.getBaseProjIntro());
        req.setBaseProjStartTime(String.valueOf(apply.getBaseProjStartTime()));
        req.setBaseProjEndTime(String.valueOf(apply.getBaseProjEndTime()));
        req.setBaseProjSetYear(apply.getBaseProjSetYear());
        req.setBaseProjSys(apply.getBaseProjSys());
        req.setBaseProjSysCode(apply.getBaseDevelopCode());
        req.setBaseProjDeclAmount(String.valueOf(apply.getBaseProjDeclAmount()));
        req.setBaseProjTotalAmount(String.valueOf(apply.getBaseProjTotalAmount()));
        req.setBaseBasisAmountOri(apply.getBaseBasisAmountOri());
        req.setBaseProjAmountOri(apply.getBaseProjAmountOri());
        req.setBaseProjRemark(apply.getBaseProjRemark());
        req.setBeseExpectedResults(apply.getBeseExpectedResults());
        return req;
    }

    public static ProjectBaseInfoReq convertBase(GovBizProjectBaseinfoDTO baseinfo) {
        ProjectBaseInfoReq req = BeanUtil.copyProperties(baseinfo,ProjectBaseInfoReq.class);
        return req;
    }
}
