package com.ningdatech.syndataapi.open.controller;

import com.ningdatech.basic.model.ApiResponse;
import com.ningdatech.syndataapi.open.manage.ProjectReceiveManage;
import com.ningdatech.syndataapi.scheduler.model.dto.ProjectBaseInfoDTO;
import com.ningdatech.syndataapi.scheduler.model.dto.ProjectSaveDTO;
import com.ningdatech.syndataapi.scheduler.model.entity.ProjectBaseInfo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
 * @Classname ProjectCollectionController
 * @Description
 * @Date 2023/6/25 9:11
 * @Author PoffyZhang
 */
@RestController
@RequiredArgsConstructor
@Api(tags = "项目归集控制器")
@RequestMapping("/open/api/v1/project-receive")
public class ProjectReceiveController {

    private final ProjectReceiveManage receiveManage;

    @PostMapping("/save")
    @ApiOperation("项目归集接收")
    public ApiResponse<String> save(@Valid @RequestBody ProjectSaveDTO dto) {
        return ApiResponse.ofSuccess(receiveManage.save(dto));
    }

    @PostMapping("/not-effective")
    @ApiOperation("项目归集置为无效")
    public ApiResponse<String> notEffective(@Valid @RequestBody ProjectBaseInfoDTO baseinfo) {
        return ApiResponse.ofSuccess(receiveManage.notEffective(baseinfo));
    }
}
